#ifndef PERFORMANCECALCULATOR_H
#define PERFORMANCECALCULATOR_H
#include <PortfolioPerformanceInput.h>
#include <PortfolioPerformanceOutput.h>
#include <vector>

using namespace std;

class PerformanceCalculator
{
    public:
        PerformanceCalculator();
        virtual ~PerformanceCalculator();
        PortfolioPerformanceOutput calculate(PortfolioPerformanceInput input);
    protected:

        template <typename T>
        NumericMatrix convertToRcppNumericMatrix(vector< vector<T> > m);

        template <typename T>
        NumericVector convertToRcppNumericVector(vector<T> v);

        template <typename T>
        CharacterVector convertToRcppCharacterVector(vector<T> v);

        template <typename T>
        DateVector convertToRcppDateVector(vector<T> v);
    private:
};

#endif // PERFORMANCECALCULATOR_H
