#include <string>
#include <vector>
#include <RInside.h>
#include <PortfolioPerformanceInput.h>
#include <PortfolioPerformanceOutput.h>
#include <PerformanceCalculator.h>

using namespace std;
using namespace Rcpp;

PerformanceCalculator::PerformanceCalculator()
{
    //ctor
}

PerformanceCalculator::~PerformanceCalculator()
{
    //dtor
}

PortfolioPerformanceOutput PerformanceCalculator::calculate(PortfolioPerformanceInput input)
{
    int argc = 0;
    char * argv[] = {};

    RInside R(argc, argv);

    for (unsigned i = 0; i < input.libraries.size(); i++)
    {
        string library = "library(" + input.libraries[i] + ")";
        R.parseEval(library);
    }

    /*
    R["nav_in"] = convertToRcppNumericVector(input.nav);
    R["cashFlows_in"] = convertToRcppNumericMatrix(input.cashFlows);
    R["dates_in"] = convertToRcppCharacterVector(input.dates);
    R["indexesBmk_in"] = convertToRcppNumericMatrix(input.indexesBmk);
    R["weightsBmk_in"] = convertToRcppNumericMatrix(input.weightsBmk);
    R["benchmark_in"] = input.benchmark;
    R["datesBmk_in"] = convertToRcppCharacterVector(input.datesBmk);
    R["creationDate_in"] = input.creationDate;
    R["activationDate_in"] = input.activationDate;
    R["finalDate_in"] = input.finalDate;
    R["start_in"] = input.start;
    R["type_in"] = input.type;
    */

    R["nav_in"] = input.nav;
    R["cashFlows_in"] = input.cashFlows;
    R["dates_in"] = input.dates;
    R["indexesBmk_in"] = input.indexesBmk;
    R["weightsBmk_in"] = input.weightsBmk;
    R["benchmark_in"] = input.benchmark;
    R["datesBmk_in"] = input.datesBmk;
    R["creationDate_in"] = input.creationDate;
    R["activationDate_in"] = input.activationDate;
    R["finalDate_in"] = input.finalDate;
    R["start_in"] = input.start;
    R["type_in"] = input.type;

    SEXP res;

    string evalstr = "res <- portfolioBenchmark(nav_in, cashFlows_in, dates_in, indexesBmk_in, weightsBmk_in, benchmark_in, datesBmk_in, creationDate_in, activationDate_in, finalDate_in, start_in, type_in); res";
    res = R.parseEval(evalstr);

    //vector<string> conv = as< vector<string> >(res);

    // TODO
    PortfolioPerformanceOutput *ppo = new PortfolioPerformanceOutput;
    return *ppo;

}

template <typename T>
NumericMatrix PerformanceCalculator::convertToRcppNumericMatrix(vector< vector<T> > m)
{
    if (!m.empty())
    {
        int rows = m.size();
        int cols = m[0].size();
        NumericMatrix M(rows,cols);
        for (int i = 0; i < rows; i++)
        {
            for (int j = 0; j < cols; j++)
            {
                M(i,j) = m[i][j];
            }
        }
        return M;
    }
    else
    {
        return NULL;
    }
}

template <typename T>
NumericVector PerformanceCalculator::convertToRcppNumericVector(vector<T> v)
{
    if (!v.empty())
    {
        int size = v.size();
        NumericVector V(size);
        for (int i = 0; i < size; i++)
        {
            V(i) = v[i];
        }
        return V;
    }
    else
    {
        return NULL;
    }
}

template <typename T>
CharacterVector PerformanceCalculator::convertToRcppCharacterVector(vector<T> v)
{
    if (!v.empty())
    {
        int size = v.size();
        CharacterVector V(size);
        for (int i = 0; i < size; i++)
        {
            V(i) = v[i];
        }
        return V;
    }
    else
    {
        return NULL;
    }

}

template <typename T>
DateVector PerformanceCalculator::convertToRcppDateVector(vector<T> v)
{
    if (!v.empty())
    {
        int size = v.size();
        DateVector V(size);
        for (int i = 0; i < size; i++)
        {
            V(i) = Date(v[i], "%Y-%m-%d");
        }
        return V;
    }
    else
    {
        return NULL;
    }
}
